diff --git a/test/test/Makefile b/test/test/Makefile
index eccc8efcf..039b6ac6d 100644
--- a/test/test/Makefile
+++ b/test/test/Makefile
@@ -179,6 +179,7 @@ SRCS-$(CONFIG_RTE_LIBRTE_PMD_RING) += test_pmd_ring_perf.c
 
 SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev_blockcipher.c
 SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev.c
+SRCS-$(CONFIG_RTE_LIBRTE_BITRATE) += test_bitratestats.c
 
 ifeq ($(CONFIG_RTE_COMPRESSDEV_TEST),y)
 SRCS-$(CONFIG_RTE_LIBRTE_COMPRESSDEV) += test_compressdev.c
diff --git a/test/test/autotest_data.py b/test/test/autotest_data.py
index aacfe0a66..419520342 100644
--- a/test/test/autotest_data.py
+++ b/test/test/autotest_data.py
@@ -293,6 +293,12 @@ def per_sockets(num):
         "Tests":
         [
             {
+                "Name":    "Bitratestats autotest",
+                "Command": "bitratestats_autotest",
+                "Func":    default_autotest,
+                "Report":  None,
+            },
+            {
                 "Name":    "PMD ring autotest",
                 "Command": "ring_pmd_autotest",
                 "Func":    default_autotest,
diff --git a/test/test/test_bitratestats.c b/test/test/test_bitratestats.c
new file mode 100644
index 000000000..8014475af
--- /dev/null
+++ b/test/test/test_bitratestats.c
@@ -0,0 +1,187 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(c) 2018 Intel Corporation
+ */
+
+#include <string.h>
+#include <errno.h>
+#include <time.h>
+
+#include <rte_log.h>
+#include <rte_lcore.h>
+#include <rte_malloc.h>
+#include <rte_common.h>
+#include <rte_metrics.h>
+#include <rte_bitrate.h>
+
+#include "test.h"
+#include "sample_packet_forward.h"
+
+extern int tx_portid, rx_portid;
+struct rte_stats_bitrates *bitrate_data;
+
+/* To test whether rte_stats_bitrate_create is successful */
+static int
+test_stats_bitrate_create(void)
+{
+	bitrate_data = rte_stats_bitrate_create();
+	TEST_ASSERT(bitrate_data != NULL, "rte_stats_bitrate_create failed");
+
+	return TEST_SUCCESS;
+}
+
+/* To test bit rate registration */
+static int
+test_stats_bitrate_reg(void)
+{
+	int ret = 0;
+
+	/* Test to register bit rate without metrics init */
+	ret = rte_stats_bitrate_reg(bitrate_data);
+	TEST_ASSERT(ret < 0, "Test Failed: rte_stats_bitrate_reg succeeded "
+			"without metrics init, ret:%d", ret);
+
+	/* Metrics initialization */
+	rte_metrics_init(rte_socket_id());
+
+	/* Test to register bit rate after metrics init */
+	ret = rte_stats_bitrate_reg(bitrate_data);
+	TEST_ASSERT((ret >= 0), "Test Failed: rte_stats_bitrate_reg %d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate registration with invalid pointer */
+static int
+test_stats_bitrate_reg_invalidpointer(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_reg(NULL);
+	TEST_ASSERT(ret < 0, "Test Failed: Expected failure < 0 but "
+			"got %d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test bit rate calculation with invalid bit rate data pointer */
+static int
+test_stats_bitrate_calc_invalid_bitrate_data(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(NULL, tx_portid);
+	TEST_ASSERT(ret < 0, "Test Failed: rte_stats_bitrate_calc "
+			"ret:%d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with invalid portid
+ * (higher than max ports)
+ */
+static int
+test_stats_bitrate_calc_invalid_portid_1(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, 33);
+	TEST_ASSERT(ret == -EINVAL, "Test Failed: Expected -%d for higher "
+			"portid rte_stats_bitrate_calc ret:%d", EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with invalid portid (lesser than 0) */
+static int
+test_stats_bitrate_calc_invalid_portid_2(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, -1);
+	TEST_ASSERT(ret == -EINVAL, "Test Failed: Expected -%d for invalid "
+			"portid rte_stats_bitrate_calc ret:%d", EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with non-existing portid */
+static int
+test_stats_bitrate_calc_non_existing_portid(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, 31);
+	TEST_ASSERT(ret ==  -EINVAL, "Test Failed: Expected -%d for "
+			"non-existing portid rte_stats_bitrate_calc ret:%d",
+			EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with valid bit rate data, valid portid */
+static int
+test_stats_bitrate_calc(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, tx_portid);
+	TEST_ASSERT(ret >= 0, "Test Failed: Expected >=0 for valid portid "
+			"rte_stats_bitrate_calc ret:%d", ret);
+
+	return TEST_SUCCESS;
+}
+
+static struct
+unit_test_suite bitratestats_testsuite  = {
+	.suite_name = "BitRate Stats Unit Test Suite",
+	.setup = test_ring_setup,
+	.teardown = NULL,
+	.unit_test_cases = {
+		/* TEST CASE 1: Test to create bit rate data */
+		TEST_CASE(test_stats_bitrate_create),
+
+		/* TEST CASE 2: Test to register bit rate metrics
+		 * without metrics init and after metrics init
+		 */
+		TEST_CASE(test_stats_bitrate_reg),
+
+		/* TEST CASE 3: Test to register bit rate metrics
+		 * with invalid bit rate data
+		 */
+		TEST_CASE(test_stats_bitrate_reg_invalidpointer),
+
+		/* TEST CASE 4: Test to calculate bit rate data metrics
+		 * with invalid bit rate data
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_bitrate_data),
+
+		/* TEST CASE 5: Test to calculate bit rate data metrics
+		 * with portid exceeding the max ports
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_portid_1),
+
+		/* TEST CASE 6: Test to calculate bit rate data metrics
+		 * with portid less than 0
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_portid_2),
+
+		/* TEST CASE 7: Test to calculate bit rate data metrics
+		 * with non-existing portid
+		 */
+		TEST_CASE(test_stats_bitrate_calc_non_existing_portid),
+
+		/* TEST CASE 8: Test to calculate bit rate data metrics
+		 * with valid portid, valid bit rate data
+		 */
+		TEST_CASE_ST(test_packet_forward, NULL,
+				test_stats_bitrate_calc),
+		TEST_CASES_END()
+	}
+};
+
+static int
+test_bitratestats(void)
+{
+	return unit_test_suite_runner(&bitratestats_testsuite);
+}
+REGISTER_TEST_COMMAND(bitratestats_autotest, test_bitratestats);